[![Version](https://img.shields.io/pypi/v/fair-test)](https://pypi.org/project/fair-test) [![Python versions](https://img.shields.io/pypi/pyversions/fair-test)](https://pypi.org/project/fair-test)

[![Run tests](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/run-tests.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/run-tests.yml) [![CodeQL](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/codeql-analysis.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/codeql-analysis.yml) [![Coverage](https://sonarcloud.io/api/project_badges/measure?project=MaastrichtU-IDS_fair-test&metric=coverage)](https://sonarcloud.io/dashboard?id=MaastrichtU-IDS_fair-test)

[![Publish to PyPI](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-package.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-package.yml) [![Publish docs](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-docs.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-docs.yml)

### 📥 Install for development

Clone the repository and install the dependencies locally for development:

```bash
git clone https://github.com/MaastrichtU-IDS/fair-test
cd fair-test
pip install -e .
```

<details><summary>If you are facing issues, use a virtual environment to avoid conflicts</summary>
<br/>
Create the virtual environment folder in your workspace:

```bash
python3 -m venv .venv
```

Activate the virtual environment:

```bash
source .venv/bin/activate
```
</details>

### ✅ Run the tests

[![Run tests](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/run-tests.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/run-tests.yml) [![Coverage](https://sonarcloud.io/api/project_badges/measure?project=MaastrichtU-IDS_fair-test&metric=coverage)](https://sonarcloud.io/dashboard?id=MaastrichtU-IDS_fair-test)

Tests are automatically run by a GitHub Actions workflow when new code is pushed to the GitHub repository. Subject URLs to test are retrieved from the `test_test` attribute for each metric test.

<details><summary>Install <code>pytest</code> for testing</summary>

```bash
pip install pytest
```
</details>

Run the tests locally (from the root folder) with prints displayed:

```bash
pytest -s
```

### 📖 Generate docs

[![Publish docs](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-docs.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-docs.yml)

Documentation is automatically generated by a GitHub Actions workflow, using the markdown files in the `docs` folder and python docstring comments.

Install the dependencies to generate documentation:

```bash
pip install -r docs/requirements.txt
```

Start the docs on [http://localhost:8001](http://localhost:8001){:target="_blank"}

```bash
mkdocs serve -a localhost:8001
```

### 🏷️ Publish a new release

[![Publish to PyPI](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-package.yml/badge.svg)](https://github.com/MaastrichtU-IDS/fair-test/actions/workflows/publish-package.yml)

1. Increment the version in `setup.py`
2. Push to GitHub
3. Create a new release on GitHub
4. A GitHub Action workflow will automatically publish the new version to PyPI
